function [B,T,f]=normvari(A);
% produces NORMALIZED varimax rotated version of A and rotation matrix T
%
% input: A    (matrix to be rotated)
% output: B (rotated A)
%	  T (rotation matrix)
%	  f (varimax function)

[m,r]=size(A);
d=sum(A.^2')';  % check on near zero rows, which will not be weighted
w=d<1e-16;
d(w)=ones(sum(w),1);
A=A./((d.^.5)*ones(1,r));
[B,T,f]=varim(A);
B=((d.^.5)*ones(1,r)).*B;
