function plotje(X,id,minx,maxx,miny,maxy,fs)
% plotje(X,id,minx,maxx,miny,maxy,fs)
% plots first two columns with respect to cartesian axes
%
% Input:
%     X: data to be plotted
% Optional input:
%   id: vector of labels to be used in plot; all labels must have same size 
%   minx, maxx, miny, maxy: min and max of X-axis, and Y-aixs, resp. 
%   fs: fontsize 

if nargin<7,fs=10;end;
if nargin<3
  minx=min(X(:,1));minx=minx-.1*abs(minx);
  maxx=max(X(:,1));maxx=maxx+.1*abs(maxx);
  miny=min(X(:,2));miny=miny-.1*abs(miny);
  maxy=max(X(:,2));maxy=maxy+.1*abs(maxy);
end;
clf;
axes('pos',[.1 .1 .62 .825],'Fontsize',fs,'Box','on');	
		% adjustment of aspectratio for printer 
axis([minx maxx miny maxy]);
text(X(:,1),X(:,2),id,'FontSize',fs);

