function [A,B,C,la,lb,lc]=pcasup3(X,n,m,p);
% [A,B,C,la,lb,lc]=pcasup3(X,n,m,p);
% PCASUP3
%
% PCASUP analysis in all 3 directions
% computes Tucker's (1966) solutions
%
% uses permnew.m ed.m writescr.m

[A,L]=ed(X*X');
disp('  ');
disp(' PCASUP: eigenvalues mode A');
disp('  ');la=diag(L);writescr([la cumsum(la)/sum(la)*100],'8.2');

X=permnew(X,n,m,p);
[B,L]=ed(X*X');
disp('  ');
disp(' PCASUP: eigenvalues mode B');
disp('  ');lb=diag(L);writescr([lb cumsum(lb)/sum(lb)*100],'8.2');

X=permnew(X,m,p,n);
[C,L]=ed(X*X');
disp('  ');
disp(' PCASUP: eigenvalues mode C');
disp('  ');lc=diag(L);writescr([lc cumsum(lc)/sum(lc)*100],'8.2');
